<?php
//ini_set("display_errors", "1"); // Debug
//error_reporting(E_ALL); // Debug
ini_set("memory_limit","50M");


if(!isset($_GET["file"])){
	echo "Måste skicka med en fil";
	exit;
}

if(!isset($_GET["width"]) and !isset($_GET["height"])){
	echo "Måste ange nya bredden eller höjden";
	exit;
}

$imgfile = $_GET["file"];

$noenlarge = isset($_GET["noenlarge"]);

// om det inte är en bild görs en som säger det...
if( !(file_exists($imgfile)) or !$imageinfo = getimagesize($imgfile)){
	if(!isset($_GET["width"])) $_GET["width"] = 150;
	if(!isset($_GET["heigt"])) $_GET["height"] = 150;
	header ("Content-type: image/png");
	$im = @imagecreate ($_GET["width"], $_GET["height"])
	    or die ("Cannot Initialize new GD image stream");
	$background_color = imagecolorallocate ($im, 255, 255, 255);
	$text_color = imagecolorallocate ($im, 33, 104, 130);
	imagestring ($im, 7, 3, 5,  "Ingen bild", $text_color);
	imagepng ($im);
	imagedestroy ($im);
	exit;
}

//print_r($imageinfo); // Debug
//exit; // Debug

// Plockar ut bredd och höjd
list($width, $height) = $imageinfo;

// Behåller propotionerna
if(!isset($_GET["width"]) and isset($_GET["height"])) {
	$newheight = $_GET["height"];
	$newwidth = (int) (($width*$newheight)/$height);
}
if(isset($_GET["width"]) and !isset($_GET["height"])) {
	$newwidth = $_GET["width"];
	$newheight = (int) (($height*$newwidth)/$width);
}

// Ändra proportionerna
if(isset($_GET["width"]) and isset($_GET["height"])){
	$newwidth = $_GET["width"];
	$newheight = $_GET["height"];
	if ($noenlarge) {
		$newwidthprop = (int) (($width*$newheight)/$height);
		$newheightprop = (int) (($height*$newwidth)/$width);
		if ($newwidth > $newwidthprop)
			$newwidth = $newwidthprop;
		if ($newheight > $newheightprop)
			$newheight = $newheightprop;
	}
}


$thumb = ImageCreateTrueColor($newwidth,$newheight);


header("Content-type: ".$imageinfo["mime"]);
// Hittar rätt filtyp och visa bilden
switch($imageinfo["mime"]){
	case "image/jpeg":
		$source = ImageCreateFromJpeg($imgfile);
		if ($noenlarge && ($newwidth > $width || $newheight > $height)) {
			ImageJpeg($source);
		} else {
			ImageCopyResized($thumb, $source, 0, 0, 0, 0, $newwidth, $newheight, $width, $height);
			ImageJpeg($thumb);
		}
	break;
	case "image/png":
		imagesavealpha($thumb, true);
		$trans_colour = imagecolorallocatealpha($thumb, 0, 0, 0, 127);
		imagefill($thumb, 0, 0, $trans_colour);
		$source = ImageCreateFromPng($imgfile);
		if ($noenlarge && ($newwidth > $width || $newheight > $height)) {
			ImagePNG($source);
		} else {
			ImageCopyResized($thumb, $source, 0, 0, 0, 0, $newwidth, $newheight, $width, $height);
			ImagePNG($thumb);
		}
	break;
	case "image/gif":
		$source = ImageCreateFromGif($imgfile);
		if ($noenlarge && ($newwidth > $width || $newheight > $height)) {
			ImageGIF($source);
		} else {
			ImageCopyResized($thumb, $source, 0, 0, 0, 0, $newwidth, $newheight, $width, $height);
			ImageGIF($thumb);
		}
	break;
}

imagedestroy($thumb);
